commit e6518ce7125919e8d466f036091c6a328b2c8c46
Author: Marei Peischl <marei@peitex.de>
Date:   Thu Jul 29 12:58:14 2021 +0200

    marei: remove leftover tabs

diff --git a/templates/print/marei/check.tex b/templates/print/marei/check.tex
index 2d55cbde0..ad428f7de 100644
--- a/templates/print/marei/check.tex
+++ b/templates/print/marei/check.tex
@@ -16,15 +16,15 @@
 \setplength{firstheadvpos}{4cm}
 
 \setkomavar{firsthead}{
-	\noindent\begin{tabular}[t]{@{}l@{}}
-		<%company%>\strut\\
-		<%address%>
-	\end{tabular}
-	\hfill
-	<%source%>\par
-	\medskip
-	<%text\_amount%> \dotfill <%decimal%>/100 \par\smallskip
-	\hfill <%datepaid%> \hspace{2cm}\strut<%amount%>
+  \noindent\begin{tabular}[t]{@{}l@{}}
+    <%company%>\strut\\
+    <%address%>
+  \end{tabular}
+  \hfill
+  <%source%>\par
+  \medskip
+  <%text\_amount%> \dotfill <%decimal%>/100 \par\smallskip
+  \hfill <%datepaid%> \hspace{2cm}\strut<%amount%>
 }
 
 
diff --git a/templates/print/marei/credit_note.tex b/templates/print/marei/credit_note.tex
index aadd3ab13..b3b3071f0 100644
--- a/templates/print/marei/credit_note.tex
+++ b/templates/print/marei/credit_note.tex
@@ -16,19 +16,19 @@
 \ourhead{\kundennummer}{<%customernumber%>}{\gutschrift}{<%invnumber%>}{<%invdate%>}
 
 \setkomavar*{date}{\datum}
-\setkomavar{date}{<%transdate%>}	
+\setkomavar{date}{<%transdate%>}
 \setkomavar{customer}{<%customernumber%>}
 \setkomavar{fromname}{<%employee_name%>}
 \setkomavar{fromphone}{<%employee_tel%>}
 \setkomavar{fromemail}{<%employee_email%>}
 \setkomavar{title}{
-	\gutschrift~
-	\nr ~<%invnumber%>%
+  \gutschrift~
+  \nr ~<%invnumber%>%
 }
 
 <%if invnumber_for_credit_note%>%
-	\setkomavar*{myref}{\fuerRechnung}
-	\setkomavar{myref}{<%invnumber_for_credit_note%>}
+  \setkomavar*{myref}{\fuerRechnung}
+  \setkomavar{myref}{<%invnumber_for_credit_note%>}
 <%end if%>%
 
 
@@ -36,21 +36,21 @@
 <%if shiptoname%>%
 \makeatletter
 \begin{lrbox}\shippingAddressBox
-	\parbox{\useplength{toaddrwidth}}{
-		\backaddr@format{\scriptsize\usekomafont{backaddress}%
-			\strut\abweichendeLieferadresse
-		}
-		\par\smallskip
-		\setlength{\parskip}{\z@}
-		\par
-		\normalsize
-		<%shiptoname%>\par
-		<%if shiptocontact%> <%shiptocontact%><%end if%>\par
-		<%shiptodepartment_1%>\par
-		<%shiptodepartment_2%>\par
-		<%shiptostreet%>\par
-		<%shiptozipcode%> <%shiptocity%>%
-	}
+  \parbox{\useplength{toaddrwidth}}{
+    \backaddr@format{\scriptsize\usekomafont{backaddress}%
+      \strut\abweichendeLieferadresse
+    }
+    \par\smallskip
+    \setlength{\parskip}{\z@}
+    \par
+    \normalsize
+    <%shiptoname%>\par
+    <%if shiptocontact%> <%shiptocontact%><%end if%>\par
+    <%shiptodepartment_1%>\par
+    <%shiptodepartment_2%>\par
+    <%shiptostreet%>\par
+    <%shiptozipcode%> <%shiptocity%>%
+  }
 \end{lrbox}
 \makeatother
 <%end if%>%
diff --git a/templates/print/marei/deutsch.tex b/templates/print/marei/deutsch.tex
index bf24eeb13..7373d7060 100644
--- a/templates/print/marei/deutsch.tex
+++ b/templates/print/marei/deutsch.tex
@@ -49,7 +49,7 @@
 \newcommand{\angebot} {Angebot}
 \newcommand{\angebotsformel} {gerne unterbreiten wir Ihnen folgendes Angebot:}
 \newcommand{\angebotdanke} {Wir danken für Ihre Anfrage und hoffen, Ihnen hiermit ein interessantes Angebot gemacht zu haben.}
-\newcommand{\angebotgueltig} {Das Angebot ist freibleibend gültig bis zum}		%Danach wird das Datum eingefügt, falls das grammatisch nicht funktionieren sollte müssen wir eine ausnahme für die sprache definieren
+\newcommand{\angebotgueltig} {Das Angebot ist freibleibend gültig bis zum}% Danach wird das Datum eingefügt, falls das grammatisch nicht funktionieren sollte müssen wir eine ausnahme für die sprache definieren
 \newcommand{\angebotfragen} {Sollten Sie noch Fragen oder Änderungswünsche haben, können Sie uns gerne jederzeit unter den unten genannten Telefonnummern oder E-Mail-Adressen kontaktieren.}
 \newcommand{\angebotagb} {Bei der Durchführung des Auftrags gelten unsere AGB, die wir Ihnen gerne zuschicken.}
 \newcommand{\auftragerteilt}{Auftrag erteilt:}
diff --git a/templates/print/marei/english.tex b/templates/print/marei/english.tex
index 13f2a9ee4..c5be2c570 100644
--- a/templates/print/marei/english.tex
+++ b/templates/print/marei/english.tex
@@ -48,7 +48,7 @@
 \newcommand{\angebot} {Quotation}
 \newcommand{\angebotsformel} {we are pleased to make the following offer:}
 \newcommand{\angebotdanke} {We thank you for your request and look forward to receiving your order.}
-\newcommand{\angebotgueltig} {This offer is valid until}		%Danach wird das Datum eingefügt, falls das grammatisch nicht funktionieren sollte müssen wir eine ausnahme für die sprache definieren
+\newcommand{\angebotgueltig} {This offer is valid until}% Danach wird das Datum eingefügt, falls das grammatisch nicht funktionieren sollte müssen wir eine Ausnahme für die Sprache definieren
 \newcommand{\angebotfragen} {If you have any questions do not hesitate to conatct us.}
 \newcommand{\angebotagb} {Our general terms and conditions (AGB) apply. We will send them to you on request.}
 \newcommand{\auftragerteilt}{Order confirmed:}
diff --git a/templates/print/marei/insettings.tex b/templates/print/marei/insettings.tex
index 6cc8add0e..937255c26 100644
--- a/templates/print/marei/insettings.tex
+++ b/templates/print/marei/insettings.tex
@@ -23,7 +23,7 @@
 
 %Ganzseitiger Briefbogen als Hintergrund:
 %\DeclareNewLayer[page,background,
-%	contents={\includegraphics{Briefbogen}} %Hier muss der Dateinamen und ggf. die Bildgröße angepasst werden, falls es abweichende Maße vom Papierformat hat.
+%  contents={\includegraphics{Briefbogen}} %Hier muss der Dateinamen und ggf. die Bildgröße angepasst werden, falls es abweichende Maße vom Papierformat hat.
 %]{background}
 %\AddLayersToPageStyle{kivitendo.letter.first}{background}%Hintergrund für die erste Seite aktivieren
 %\AddLayersToPageStyle{kivitendo.letter}{background}% Hintergrund für die übrigen Briefseiten aktivieren.
@@ -105,11 +105,11 @@
     \usekomafont{pagefoot}%
     % Anfang des eigentlichen Inhaltes der Fußzeile
     \begin{tabular*}{\textwidth}[t]{@{\extracolsep{\fill}}p{.25\linewidth}p{.25\linewidth}r@{\extracolsep{0pt}\hspace{2\tabcolsep}}l@{}}%
-      \firma                 & \email              & \textKontonummer			 & \kontonummer \\
-      \strasse               & \homepage           & \textBank        		 & \bank \\
-      \ort                   & \textUstid\ \ustid  & \textIban        		 & \iban \\
-      \textTelefon~\telefon  & \finanzamt          & \textBic         		 & \bic \\
-      \Ifstr{\fax}{}{}{\textFax~\fax} & 			 &\textBankleitzahl			 & \bankleitzahl
+      \firma                 & \email              & \textKontonummer       & \kontonummer \\
+      \strasse               & \homepage           & \textBank             & \bank \\
+      \ort                   & \textUstid\ \ustid  & \textIban             & \iban \\
+      \textTelefon~\telefon  & \finanzamt          & \textBic              & \bic \\
+      \Ifstr{\fax}{}{}{\textFax~\fax} &        &\textBankleitzahl       & \bankleitzahl
     \end{tabular*}
     % Ende des Fußzeileninhaltes.
   \end{lrbox}
@@ -123,8 +123,8 @@
   \setlength{\footskip}{\dimexpr\footheight+\baselineskip}
   \geometry{
     includefoot,
-    %	bottom=1cm,% Falls der untere Rand kleiner sein soll, als die Seitenränder.
-    % 	Weitere Anpassungen der Ränder sind hier ebenfalls möglich
+    %  bottom=1cm,% Falls der untere Rand kleiner sein soll, als die Seitenränder.
+    %   Weitere Anpassungen der Ränder sind hier ebenfalls möglich
   }
 
 \fi
diff --git a/templates/print/marei/invoice.tex b/templates/print/marei/invoice.tex
index b434e0b94..9a7aa65af 100644
--- a/templates/print/marei/invoice.tex
+++ b/templates/print/marei/invoice.tex
@@ -22,18 +22,18 @@
 \setkomavar{fromphone}{<%employee_tel%>}
 \setkomavar{fromemail}{<%employee_email%>}
 \setkomavar{title}{
-	\rechnung~ \nr ~<%invnumber%>%
+  \rechnung~ \nr ~<%invnumber%>%
 }
 <%if ordnumber%>%
-	\setkomavar*{myref}{\auftragsnummer}
-	\setkomavar{myref}{<%ordnumber%>}
+  \setkomavar*{myref}{\auftragsnummer}
+  \setkomavar{myref}{<%ordnumber%>}
 <%end if%>%
 <%if cusordnumber%>%
-	\setkomavar*{yourref}{\ihreBestellnummer}
-	\setkomavar{yourref}{<%cusordnumber%>}
+  \setkomavar*{yourref}{\ihreBestellnummer}
+  \setkomavar{yourref}{<%cusordnumber%>}
 <%end if%>%
 <%if donumber%>%
-	\setkomavar{delivery}{<%donumber%>}
+  \setkomavar{delivery}{<%donumber%>}
 <%end if%>%
 
 <%if quonumber%>%
@@ -43,21 +43,21 @@
 <%if shiptoname%>%
 \makeatletter
 \begin{lrbox}\shippingAddressBox
-	\parbox{\useplength{toaddrwidth}}{
-		\backaddr@format{\scriptsize\usekomafont{backaddress}%
-			\strut\abweichendeLieferadresse
-		}
-		\par\smallskip
-		\setlength{\parskip}{\z@}
-		\par
-		\normalsize
-		<%shiptoname%>\par
-		<%if shiptocontact%> <%shiptocontact%><%end if%>\par
-		<%shiptodepartment_1%>\par
-		<%shiptodepartment_2%>\par
-		<%shiptostreet%>\par
-		<%shiptozipcode%> <%shiptocity%>%
-	}
+  \parbox{\useplength{toaddrwidth}}{
+    \backaddr@format{\scriptsize\usekomafont{backaddress}%
+      \strut\abweichendeLieferadresse
+    }
+    \par\smallskip
+    \setlength{\parskip}{\z@}
+    \par
+    \normalsize
+    <%shiptoname%>\par
+    <%if shiptocontact%> <%shiptocontact%><%end if%>\par
+    <%shiptodepartment_1%>\par
+    <%shiptodepartment_2%>\par
+    <%shiptostreet%>\par
+    <%shiptozipcode%> <%shiptocity%>%
+  }
 \end{lrbox}
 \makeatother
 <%end if%>%
diff --git a/templates/print/marei/kiviletter.sty b/templates/print/marei/kiviletter.sty
index 0705c0db1..0ea200532 100644
--- a/templates/print/marei/kiviletter.sty
+++ b/templates/print/marei/kiviletter.sty
@@ -212,23 +212,23 @@
 \tcbuselibrary{breakable, skins}
 
 \tcb@new@skin{kivi@LT}{base@unbroken,%
-frame~engine=empty,interior~titled~engine=empty,interior~engine=empty,segmentation~engine=empty,title~engine=empty,%
-skin~first=kivi@LT@first,skin~middle=kivi@LT@middle,skin~last=kivi@LT@last,
-underlay~first~and~middle={
-\node[anchor=north]  at (interior.north)  {\csname box_use:c\endcsname  {g_kivi_LT@head_box}};
-\node[anchor=south]  at (interior.south)  {\csname box_use:c\endcsname  {g_kivi_LT@foot_box}};
-},
-underlay~unbroken~and~last={
-\node[anchor=north]  at (interior.north)  {\csname box_use:c\endcsname  {g_kivi_LT@head_box}};
-\node[anchor=south]  at (interior.south)  {\csname box_use:c\endcsname  {g_kivi_LT@lastfoot_box}};
+  frame~engine=empty,interior~titled~engine=empty,interior~engine=empty,segmentation~engine=empty,title~engine=empty,%
+  skin~first=kivi@LT@first,skin~middle=kivi@LT@middle,skin~last=kivi@LT@last,
+  underlay~first~and~middle={
+    \node[anchor=north]  at (interior.north)  {\csname box_use:c\endcsname  {g_kivi_LT@head_box}};
+    \node[anchor=south]  at (interior.south)  {\csname box_use:c\endcsname  {g_kivi_LT@foot_box}};
 },
-boxsep=0pt,
-boxrule=0pt,
-left=0pt,
-right=0pt,
-bottom=\box_ht:N  \g_kivi_LT@foot_box+\box_dp:N  \g_kivi_LT@foot_box + \aboverulesep,
-top=\box_ht:N  \g_kivi_LT@head_box+\box_dp:N  \g_kivi_LT@head_box +\belowrulesep,
-parbox=false,
+  underlay~unbroken~and~last={
+    \node[anchor=north]  at (interior.north)  {\csname box_use:c\endcsname  {g_kivi_LT@head_box}};
+    \node[anchor=south]  at (interior.south)  {\csname box_use:c\endcsname  {g_kivi_LT@lastfoot_box}};
+  },
+  boxsep=0pt,
+  boxrule=0pt,
+  left=0pt,
+  right=0pt,
+  bottom=\box_ht:N  \g_kivi_LT@foot_box+\box_dp:N  \g_kivi_LT@foot_box + \aboverulesep,
+  top=\box_ht:N  \g_kivi_LT@head_box+\box_dp:N  \g_kivi_LT@head_box +\belowrulesep,
+  parbox=false,
 }
 
 \tcb@new@skin{kivi@LT@first}{base@first,%
@@ -341,14 +341,14 @@ parbox=false,
 
 \tl_new:N \g_kivi_Pricing_colspec_tl
 \tl_gset:Nn \g_kivi_Pricing_colspec_tl {
-\bool_if:NF \g__kivi_Tabular_rowcolor_bool {@{}}
-\bool_if:NT \l_kivi_col_pos_bool {p{\l_kivi_tab_pos_dim}}
-\bool_if:NT \l_kivi_col_id_bool {p{\l_kivi_tab_id_dim}}
-p{\l_kivi_tab_desc_dim}
-\bool_if:NT \l_kivi_col_amount_bool {\exp_not:n {>{\raggedleft\arraybackslash}p{\l_kivi_tab_amount_dim}}}
-\bool_if:NT \l_kivi_col_price_bool {\exp_not:n {>{\raggedleft\arraybackslash}p{\l_kivi_tab_price_dim}<{\__kivi_tab_column_currency:}}}
-\bool_if:NT \l_kivi_col_pricetotal_bool {\exp_not:n {>{\raggedleft\arraybackslash}p{\l_kivi_tab_pricetotal_dim}<{\__kivi_tab_column_currency:}}}
-\bool_if:NF \g__kivi_Tabular_rowcolor_bool {@{}}
+  \bool_if:NF \g__kivi_Tabular_rowcolor_bool {@{}}
+  \bool_if:NT \l_kivi_col_pos_bool {p{\l_kivi_tab_pos_dim}}
+  \bool_if:NT \l_kivi_col_id_bool {p{\l_kivi_tab_id_dim}}
+  p{\l_kivi_tab_desc_dim}
+  \bool_if:NT \l_kivi_col_amount_bool {\exp_not:n {>{\raggedleft\arraybackslash}p{\l_kivi_tab_amount_dim}}}
+  \bool_if:NT \l_kivi_col_price_bool {\exp_not:n {>{\raggedleft\arraybackslash}p{\l_kivi_tab_price_dim}<{\__kivi_tab_column_currency:}}}
+  \bool_if:NT \l_kivi_col_pricetotal_bool {\exp_not:n {>{\raggedleft\arraybackslash}p{\l_kivi_tab_pricetotal_dim}<{\__kivi_tab_column_currency:}}}
+  \bool_if:NF \g__kivi_Tabular_rowcolor_bool {@{}}
 }
 
 \cs_new_protected:Nn \__kivi_tab_column_currency: {\,\currency}
@@ -393,16 +393,18 @@ p{\l_kivi_tab_desc_dim}
 
 %Macht es sinn hier eine Variante zu machen, in der alle Spalten Belegbar sind?
 \NewDocumentEnvironment{PricingTotal}{+b}{
-\par\nointerlineskip
+  \par\nointerlineskip
 }{
-\bool_if:NT \g__kivi_Tabular_rowcolor_bool 	{\nointerlineskip\kivi@tabcolorbox{\g__kivi_Tabular_rowcolor_PricingTotal_tl}}
-{
-\tabular[t]{@{\bool_if:NT \g__kivi_Tabular_rowcolor_bool {\hskip\tabcolsep}}
-p{\dim_eval:n {\linewidth-\l_kivi_tab_pricetotal_dim-\bool_if:NTF \g__kivi_Tabular_rowcolor_bool {4}{2}\tabcolsep}}P{\l_kivi_tab_pricetotal_dim}@{\bool_if:NT \g__kivi_Tabular_rowcolor_bool {\hskip\tabcolsep}}}
-\l__kivi_Tabular_PricingTotal_topsep_tl
-#1
-\endtabular
-}
+  \bool_if:NT \g__kivi_Tabular_rowcolor_bool 	{\nointerlineskip\kivi@tabcolorbox{\g__kivi_Tabular_rowcolor_PricingTotal_tl}}
+  {
+    \tabular[t]{
+      @{\bool_if:NT \g__kivi_Tabular_rowcolor_bool {\hskip\tabcolsep}}
+      p{\dim_eval:n {\linewidth-\l_kivi_tab_pricetotal_dim-\bool_if:NTF \g__kivi_Tabular_rowcolor_bool {4}{2}\tabcolsep}}P{\l_kivi_tab_pricetotal_dim}@{\bool_if:NT \g__kivi_Tabular_rowcolor_bool {\hskip\tabcolsep}}
+    }
+    \l__kivi_Tabular_PricingTotal_topsep_tl
+    #1
+    \endtabular
+  }
 }
 
 \tl_new:N \l__kivi_Tabular_PricingTotal_topsep_tl
diff --git a/templates/print/marei/purchase_delivery_order.tex b/templates/print/marei/purchase_delivery_order.tex
index e84430e9a..123eef8c6 100644
--- a/templates/print/marei/purchase_delivery_order.tex
+++ b/templates/print/marei/purchase_delivery_order.tex
@@ -22,19 +22,19 @@
 \setkomavar{fromphone}{<%employee_tel%>}
 \setkomavar{fromemail}{<%employee_email%>}
 \setkomavar{title}{
-	\einkaufslieferschein~\nr ~<%donumber%>%
+  \einkaufslieferschein~\nr ~<%donumber%>%
 }
 <%if ordnumber%>
-	\setkomavar{orderID}{<%ordnumber%>}
+  \setkomavar{orderID}{<%ordnumber%>}
 <%end if%>%
 <%if cusordnumber%>%
-	\setkomavar*{yourref}{\unsereBestellnummer}
-	\setkomavar{yourref}{<%cusordnumber%>}
+  \setkomavar*{yourref}{\unsereBestellnummer}
+  \setkomavar{yourref}{<%cusordnumber%>}
 <%end if%>%
 \setkomavar{transaction}{<%transaction_description%>}
 
 <%if globalprojectnumber%>%
-	\setkomavar{projectID}{<%globalprojectnumber%>}
+  \setkomavar{projectID}{<%globalprojectnumber%>}
 <%end globalprojectnumber%>%
 
 \setkomavar{transaction}{<%transaction_description%>}
@@ -43,21 +43,21 @@
 <%if shiptoname%>%
 \makeatletter
 \begin{lrbox}\shippingAddressBox
-	\parbox{\useplength{toaddrwidth}}{
-		\backaddr@format{\scriptsize\usekomafont{backaddress}%
-			\strut\abweichendeLieferadresse
-		}
-		\par\smallskip
-		\setlength{\parskip}{\z@}
-		\par
-		\normalsize
-		<%shiptoname%>\par
-		<%if shiptocontact%> <%shiptocontact%><%end if%>\par
-		<%shiptodepartment_1%>\par
-		<%shiptodepartment_2%>\par
-		<%shiptostreet%>\par
-		<%shiptozipcode%> <%shiptocity%>%
-	}
+  \parbox{\useplength{toaddrwidth}}{
+    \backaddr@format{\scriptsize\usekomafont{backaddress}%
+      \strut\abweichendeLieferadresse
+    }
+    \par\smallskip
+    \setlength{\parskip}{\z@}
+    \par
+    \normalsize
+    <%shiptoname%>\par
+    <%if shiptocontact%> <%shiptocontact%><%end if%>\par
+    <%shiptodepartment_1%>\par
+    <%shiptodepartment_2%>\par
+    <%shiptostreet%>\par
+    <%shiptozipcode%> <%shiptocity%>%
+  }
 \end{lrbox}
 \makeatother
 <%end if%>%
diff --git a/templates/print/marei/purchase_order.tex b/templates/print/marei/purchase_order.tex
index 36eda4fb0..9c8d610f0 100644
--- a/templates/print/marei/purchase_order.tex
+++ b/templates/print/marei/purchase_order.tex
@@ -23,38 +23,38 @@
 \setkomavar{fromphone}{<%employee_tel%>}
 \setkomavar{fromemail}{<%employee_email%>}
 \setkomavar{title}{
-	\bestellung~
-	\nr~<%ordnumber%>%
+  \bestellung~
+  \nr~<%ordnumber%>%
 }
 
 <%if cusordnumber%>%
-	\setkomavar*{yourref}{\unsereBestellnummer}
-	\setkomavar{yourref}{<%cusordnumber%>}
+  \setkomavar*{yourref}{\unsereBestellnummer}
+  \setkomavar{yourref}{<%cusordnumber%>}
 <%end if%>%
 \setkomavar{transaction}{<%transaction_description%>}
 
 <%if quonumber%>
-	\setkomavar{quote}{<%quonumber%>}
+  \setkomavar{quote}{<%quonumber%>}
 <%end if%>%
 
 <%if shiptoname%>%
 \makeatletter
 \begin{lrbox}\shippingAddressBox
-	\parbox{\useplength{toaddrwidth}}{
-		\backaddr@format{\scriptsize\usekomafont{backaddress}%
-			\strut abweichende Lieferadresse
-		}
-		\par\smallskip
-		\setlength{\parskip}{\z@}
-		\par
-		\normalsize
-		<%shiptoname%>\par
-		<%if shiptocontact%> <%shiptocontact%><%end if%>\par
-		<%shiptodepartment_1%>\par
-		<%shiptodepartment_2%>\par
-		<%shiptostreet%>\par
-		<%shiptozipcode%> <%shiptocity%>%
-	}
+  \parbox{\useplength{toaddrwidth}}{
+    \backaddr@format{\scriptsize\usekomafont{backaddress}%
+      \strut abweichende Lieferadresse
+    }
+    \par\smallskip
+    \setlength{\parskip}{\z@}
+    \par
+    \normalsize
+    <%shiptoname%>\par
+    <%if shiptocontact%> <%shiptocontact%><%end if%>\par
+    <%shiptodepartment_1%>\par
+    <%shiptodepartment_2%>\par
+    <%shiptostreet%>\par
+    <%shiptozipcode%> <%shiptocity%>%
+  }
 \end{lrbox}
 \makeatother
 <%end if%>%
diff --git a/templates/print/marei/receipt.tex b/templates/print/marei/receipt.tex
index 2d55cbde0..ad428f7de 100644
--- a/templates/print/marei/receipt.tex
+++ b/templates/print/marei/receipt.tex
@@ -16,15 +16,15 @@
 \setplength{firstheadvpos}{4cm}
 
 \setkomavar{firsthead}{
-	\noindent\begin{tabular}[t]{@{}l@{}}
-		<%company%>\strut\\
-		<%address%>
-	\end{tabular}
-	\hfill
-	<%source%>\par
-	\medskip
-	<%text\_amount%> \dotfill <%decimal%>/100 \par\smallskip
-	\hfill <%datepaid%> \hspace{2cm}\strut<%amount%>
+  \noindent\begin{tabular}[t]{@{}l@{}}
+    <%company%>\strut\\
+    <%address%>
+  \end{tabular}
+  \hfill
+  <%source%>\par
+  \medskip
+  <%text\_amount%> \dotfill <%decimal%>/100 \par\smallskip
+  \hfill <%datepaid%> \hspace{2cm}\strut<%amount%>
 }
 
 
diff --git a/templates/print/marei/request_quotation.tex b/templates/print/marei/request_quotation.tex
index 38478845d..0cfc11934 100644
--- a/templates/print/marei/request_quotation.tex
+++ b/templates/print/marei/request_quotation.tex
@@ -23,11 +23,11 @@
 \setkomavar{fromphone}{<%employee_tel%>}
 \setkomavar{fromemail}{<%employee_email%>}
 \setkomavar{title}{
-	\anfrage~
-	\nr ~<%quonumber%>%
+  \anfrage~
+  \nr ~<%quonumber%>%
 }
 <%if globalprojectnumber%>%
-	\setkomavar{projectID}{<%globalprojectnumber%>}
+  \setkomavar{projectID}{<%globalprojectnumber%>}
 <%end globalprojectnumber%>%
 
 \setkomavar{transaction}{<%transaction_description%>}
diff --git a/templates/print/marei/sales_delivery_order.tex b/templates/print/marei/sales_delivery_order.tex
index 69916eae0..2811e50c7 100644
--- a/templates/print/marei/sales_delivery_order.tex
+++ b/templates/print/marei/sales_delivery_order.tex
@@ -21,20 +21,20 @@
 \setkomavar{fromphone}{<%employee_tel%>}
 \setkomavar{fromemail}{<%employee_email%>}
 \setkomavar{title}{
-	\lieferschein~
-	\nr~<%donumber%>%
+  \lieferschein~
+  \nr~<%donumber%>%
 }
 <%if ordnumber%>
-	\setkomavar{orderID}{<%ordnumber%>}
+  \setkomavar{orderID}{<%ordnumber%>}
 <%end if%>%
 <%if cusordnumber%>%
-	\setkomavar*{yourref}{\unsereBestellnummer}
-	\setkomavar{yourref}{<%cusordnumber%>}
+  \setkomavar*{yourref}{\unsereBestellnummer}
+  \setkomavar{yourref}{<%cusordnumber%>}
 <%end if%>%
 \setkomavar{transaction}{<%transaction_description%>}
 
 <%if globalprojectnumber%>%
-	\setkomavar{projectID}{<%globalprojectnumber%>}
+  \setkomavar{projectID}{<%globalprojectnumber%>}
 <%end globalprojectnumber%>%
 
 \setkomavar{transaction}{<%transaction_description%>}
diff --git a/templates/print/marei/sales_order.tex b/templates/print/marei/sales_order.tex
index d809224b0..23c4a45c2 100644
--- a/templates/print/marei/sales_order.tex
+++ b/templates/print/marei/sales_order.tex
@@ -24,37 +24,37 @@
 \setkomavar{fromphone}{<%employee_tel%>}
 \setkomavar{fromemail}{<%employee_email%>}
 \setkomavar{title}{
-	\auftragsbestaetigung~
-	\nr~<%ordnumber%>%
+  \auftragsbestaetigung~
+  \nr~<%ordnumber%>%
 }
 <%if cusordnumber%>%
-	\setkomavar*{yourref}{\ihreBestellnummer}
-	\setkomavar{yourref}{<%cusordnumber%>}
+  \setkomavar*{yourref}{\ihreBestellnummer}
+  \setkomavar{yourref}{<%cusordnumber%>}
 <%end if%>%
 \setkomavar{transaction}{<%transaction_description%>}
 
 <%if quonumber%>
-	\setkomavar{quote}{<%quonumber%>}
+  \setkomavar{quote}{<%quonumber%>}
 <%end if%>%
 
 <%if shiptoname%>%
 \makeatletter
 \begin{lrbox}\shippingAddressBox
-	\parbox{\useplength{toaddrwidth}}{
-		\backaddr@format{\scriptsize\usekomafont{backaddress}%
-			\strut abweichende Lieferadresse
-		}
-		\par\smallskip
-		\setlength{\parskip}{\z@}
-		\par
-		\normalsize
-		<%shiptoname%>\par
-		<%if shiptocontact%> <%shiptocontact%><%end if%>\par
-		<%shiptodepartment_1%>\par
-		<%shiptodepartment_2%>\par
-		<%shiptostreet%>\par
-		<%shiptozipcode%> <%shiptocity%>%
-	}
+  \parbox{\useplength{toaddrwidth}}{
+    \backaddr@format{\scriptsize\usekomafont{backaddress}%
+      \strut abweichende Lieferadresse
+    }
+    \par\smallskip
+    \setlength{\parskip}{\z@}
+    \par
+    \normalsize
+    <%shiptoname%>\par
+    <%if shiptocontact%> <%shiptocontact%><%end if%>\par
+    <%shiptodepartment_1%>\par
+    <%shiptodepartment_2%>\par
+    <%shiptostreet%>\par
+    <%shiptozipcode%> <%shiptocity%>%
+  }
 \end{lrbox}
 \makeatother
 <%end if%>%
diff --git a/templates/print/marei/statement.tex b/templates/print/marei/statement.tex
index 8f6064d69..7cd91a020 100644
--- a/templates/print/marei/statement.tex
+++ b/templates/print/marei/statement.tex
@@ -17,8 +17,8 @@
 
 
 \setkomavar{title}{
-	\sammelrechnung~
-	\nr~<%quonumber%>%
+  \sammelrechnung~
+  \nr~<%quonumber%>%
 }
 \setkomavar{transaction}{<%transaction_description%>}
 \setkomavar{customer}{<%customernumber%>}
diff --git a/templates/print/marei/zahlungserinnerung.tex b/templates/print/marei/zahlungserinnerung.tex
index 749e1f3e0..abb601f78 100644
--- a/templates/print/marei/zahlungserinnerung.tex
+++ b/templates/print/marei/zahlungserinnerung.tex
@@ -22,8 +22,8 @@
 \setkomavar{fromphone}{<%employee_tel%>}
 \setkomavar{fromemail}{<%employee_email%>}
 \setkomavar{title}{
-	\mahnung
-	<%if dunning_id%>~\nr~<%dunning_id%><%end if%>%
+  \mahnung
+  <%if dunning_id%>~\nr~<%dunning_id%><%end if%>%
 }
 \setkomavar{transaction}{<%transaction_description%>}
 
diff --git a/templates/print/marei/zahlungserinnerung_invoice.tex b/templates/print/marei/zahlungserinnerung_invoice.tex
index 1f330be3e..9acdeab47 100644
--- a/templates/print/marei/zahlungserinnerung_invoice.tex
+++ b/templates/print/marei/zahlungserinnerung_invoice.tex
@@ -22,13 +22,13 @@
 \setkomavar{fromphone}{<%employee_tel%>}
 \setkomavar{fromemail}{<%employee_email%>}
 \setkomavar{title}{
-	\rechnung~
-	\nr ~<%invnumber%>%
+  \rechnung~
+  \nr ~<%invnumber%>%
 }
 \setkomavar*{myref}{\mahnung~\nr}
 \setkomavar{myref}{<%dunning_id%>}
 <%if globalprojectnumber%>%
-	\setkomavar{projectID}{<%globalprojectnumber%>}
+  \setkomavar{projectID}{<%globalprojectnumber%>}
 <%end globalprojectnumber%>%
 \setkomavar{transaction}{<%transaction_description%>}
 